diff -uNrd -x CVS ircd-hybrid-7rc5/src/s_bsd.c ircd-hybrid-7-bg/src/s_bsd.c
--- ircd-hybrid-7rc5/src/s_bsd.c	Tue Oct 29 21:56:19 2002
+++ ircd-hybrid-7-bg/src/s_bsd.c	Tue Feb  4 11:13:07 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_bsd.c,v 7.173 2002/10/30 02:56:19 androsyn Exp $
+ *  $Id: s_bsd.c,v 1.4 2003/02/04 16:13:07 demond Exp $
  */
 
 #include "stdinc.h"
@@ -49,7 +49,6 @@
 #include "s_debug.h"
 #include "memory.h"
 
-
 #ifndef IN_LOOPBACKNET
 #define IN_LOOPBACKNET        0x7f
 #endif
@@ -847,7 +846,7 @@
     }
 
   /* Next, update things in our fd tracking */
-  fd_open(fd, FD_SOCKET, note);
+  fd_open(fd, FD_SOCKET, note, NULL);
   return fd;
 }
 
@@ -859,10 +858,14 @@
  * comm_open() does.
  */
 int
-comm_accept(int fd, struct irc_sockaddr *pn)
+comm_accept(int fd, struct irc_sockaddr *pn, int is_ssl)
 {
   int newfd;
   socklen_t addrlen = sizeof(struct irc_sockaddr);
+#ifdef HAVE_LIBCRYPTO
+  SSL *ssl = NULL;
+#endif
+
   if (number_fd >= MASTER_MAX)
     {
       errno = ENFILE;
@@ -877,7 +880,7 @@
   newfd = accept(fd, (struct sockaddr *)&PSOCKADDR(pn), (socklen_t *)&addrlen);
   if (newfd < 0)
     return -1;
-
+    
   /* Set the socket non-blocking, and other wonderful bits */
   if (!set_non_blocking(newfd))
     {
@@ -886,9 +889,115 @@
       return -1;
     }
 
+#ifdef HAVE_LIBCRYPTO
+  if (is_ssl && ServerInfo.ctx) {
+    int retval;
+    extern char *get_ssl_error(int);
+  	fde_t *F = &fd_table[newfd];
+  	
+  	copy_s_addr(F->connect.hostaddr, *pn);
+  
+  	ssl = SSL_new(ServerInfo.ctx);
+  	if (!ssl) {
+  		ilog(L_CRIT, "SSL_new() ERROR! -- %s", ERR_error_string(ERR_get_error(), NULL));
+  		close(newfd);
+  		return -1;
+  	}
+  	SSL_set_fd(ssl, newfd);
+  	
+  	sendto_realops_flags(FLAGS_DEBUG, L_ALL, "SSL_accept() for %s (socket %d) in progress...",
+  		inetntoa((char *)&PS_ADDR(pn)), newfd);
+
+again:
+  	retval = SSL_accept(ssl);
+  	if (retval <= 0) {
+  		switch ((retval = SSL_get_error(ssl, retval))) {
+  		
+	    	case SSL_ERROR_SYSCALL:
+				if (errno==EINTR || errno==EWOULDBLOCK || errno==EAGAIN)
+				
+  			case SSL_ERROR_WANT_READ:
+  			case SSL_ERROR_WANT_WRITE:
+  				sendto_realops_flags(FLAGS_DEBUG, L_ALL,
+  					"SSL_accept() for %s wants read or write (%s), passing through...",
+  					inetntoa((char *)&PS_ADDR(pn)), get_ssl_error(retval));
+  					
+  				/* let it through, SSL_read()/SSL_write() will finish the handshake...*/
+  				/*goto again;*/
+  				
+  				/*SSL_set_accept_state(ssl);*/
+  				if (retval == SSL_ERROR_WANT_READ)
+  					F->flags.accept_read = 1;
+  				else if (retval == SSL_ERROR_WANT_WRITE)
+  					F->flags.accept_write = 1;
+  				else
+  					F->flags.accept_read = 1;
+  				break;
+  				
+  			default:
+  				sendto_realops_flags(FLAGS_DEBUG, L_ALL, "SSL_accept() ERROR! -- %s",
+  					(retval == SSL_ERROR_SSL)?
+  					ERR_error_string(ERR_get_error(), NULL) :
+  					get_ssl_error(retval));
+  				SSL_free(ssl);
+  				close(newfd);
+  				return -1;
+  		}
+  	} else {
+  		char *ssl_get_cipher(SSL *);
+  		/*SSL_set_accept_state(ssl);*/
+  		
+  		sendto_realops_flags(FLAGS_DEBUG, L_ALL, "SSL_accept() for %s succeeded!",
+  			inetntoa((char *)&PS_ADDR(pn)));
+  		sendto_realops_flags(FLAGS_DEBUG, L_ALL, "SSL protocol/cipher: %s",
+  			ssl_get_cipher(ssl));
+  		sendto_realops_flags(FLAGS_DEBUG, L_ALL, "SSL_state_string_long(): %s",
+  			SSL_state_string_long(ssl));
+  	}
+  }
+#endif
+
   /* Next, tag the FD as an incoming connection */
-  fd_open(newfd, FD_SOCKET, "Incoming connection");
+#ifdef HAVE_LIBCRYPTO
+  if (is_ssl && ServerInfo.ctx)
+  	fd_open(newfd, FD_SOCKET, "Incoming SSL connection", ssl);
+  else
+  	fd_open(newfd, FD_SOCKET, "Incoming connection", ssl);
+#else
+  fd_open(newfd, FD_SOCKET, "Incoming connection", NULL);
+#endif
 
   /* .. and return */
   return newfd;
 }
+
+#ifdef HAVE_LIBCRYPTO
+char *ssl_get_cipher(SSL *ssl)
+{
+	static char buf[400];
+	char bots[10];
+	int bits;
+	SSL_CIPHER *c; 
+	
+	buf[0] = '\0';
+	switch(ssl->session->ssl_version)
+	{
+		case SSL2_VERSION:
+			strcat(buf, "SSLv2"); break;
+		case SSL3_VERSION:
+			strcat(buf, "SSLv3"); break;
+		case TLS1_VERSION:
+			strcat(buf, "TLSv1"); break;
+		default:
+			strcat(buf, "UNKNOWN");
+	}
+	strcat(buf, "-");
+	strcat(buf, SSL_get_cipher(ssl));
+	c = SSL_get_current_cipher(ssl);
+	SSL_CIPHER_get_bits(c, &bits);
+	sprintf(bots, "-%d", bits);
+	strcat(buf, bots);
+	strcat(buf, "bits");
+	return (buf);
+}
+#endif
diff -uNrd -x CVS ircd-hybrid-7rc5/src/s_bsd_devpoll.c ircd-hybrid-7-bg/src/s_bsd_devpoll.c
--- ircd-hybrid-7rc5/src/s_bsd_devpoll.c	Sun Jun 16 22:57:01 2002
+++ ircd-hybrid-7-bg/src/s_bsd_devpoll.c	Mon Dec 30 23:07:27 2002
@@ -20,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_bsd_devpoll.c,v 7.15 2002/06/17 02:57:01 db Exp $
+ *  $Id: s_bsd_devpoll.c,v 1.1.1.1 2002/12/31 04:07:27 demond Exp $
  */
 
 #include "config.h"
diff -uNrd -x CVS ircd-hybrid-7rc5/src/s_bsd_kqueue.c ircd-hybrid-7-bg/src/s_bsd_kqueue.c
--- ircd-hybrid-7rc5/src/s_bsd_kqueue.c	Sat Jun 15 03:19:57 2002
+++ ircd-hybrid-7-bg/src/s_bsd_kqueue.c	Mon Dec 30 23:07:27 2002
@@ -20,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_bsd_kqueue.c,v 1.27 2002/06/15 07:19:57 androsyn Exp $
+ *  $Id: s_bsd_kqueue.c,v 1.1.1.1 2002/12/31 04:07:27 demond Exp $
  */
 
 #include "config.h"
diff -uNrd -x CVS ircd-hybrid-7rc5/src/s_bsd_poll.c ircd-hybrid-7-bg/src/s_bsd_poll.c
--- ircd-hybrid-7rc5/src/s_bsd_poll.c	Fri May 24 19:34:50 2002
+++ ircd-hybrid-7-bg/src/s_bsd_poll.c	Mon Dec 30 23:07:27 2002
@@ -20,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_bsd_poll.c,v 7.54 2002/05/24 23:34:50 androsyn Exp $
+ *  $Id: s_bsd_poll.c,v 1.1.1.1 2002/12/31 04:07:27 demond Exp $
  */
 
 #include "config.h"
diff -uNrd -x CVS ircd-hybrid-7rc5/src/s_bsd_select.c ircd-hybrid-7-bg/src/s_bsd_select.c
--- ircd-hybrid-7rc5/src/s_bsd_select.c	Fri May 24 21:42:54 2002
+++ ircd-hybrid-7-bg/src/s_bsd_select.c	Mon Dec 30 23:07:27 2002
@@ -20,7 +20,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_bsd_select.c,v 7.26 2002/05/25 01:42:54 androsyn Exp $
+ *  $Id: s_bsd_select.c,v 1.1.1.1 2002/12/31 04:07:27 demond Exp $
  */
 
 #include "config.h"
diff -uNrd -x CVS ircd-hybrid-7rc5/src/s_bsd_sigio.c ircd-hybrid-7-bg/src/s_bsd_sigio.c
--- ircd-hybrid-7rc5/src/s_bsd_sigio.c	Sat May 25 05:05:55 2002
+++ ircd-hybrid-7-bg/src/s_bsd_sigio.c	Mon Dec 30 23:07:27 2002
@@ -21,7 +21,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_bsd_sigio.c,v 7.23 2002/05/25 09:05:55 androsyn Exp $
+ *  $Id: s_bsd_sigio.c,v 1.1.1.1 2002/12/31 04:07:27 demond Exp $
  */
 
 #ifndef _GNU_SOURCE
diff -uNrd -x CVS ircd-hybrid-7rc5/src/s_conf.c ircd-hybrid-7-bg/src/s_conf.c
--- ircd-hybrid-7rc5/src/s_conf.c	Wed Oct 30 12:44:57 2002
+++ ircd-hybrid-7-bg/src/s_conf.c	Sat May 24 23:27:11 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_conf.c,v 7.332 2002/10/30 17:44:57 wiz Exp $
+ *  $Id: s_conf.c,v 1.5 2003/05/24 00:07:47 demond Exp $
  */
 
 #include "stdinc.h"
@@ -50,6 +50,7 @@
 #include "s_debug.h"
 #include "fileio.h"
 #include "memory.h"
+#include "s_misc.h"
 
 struct config_server_hide ConfigServerHide;
 
@@ -121,6 +122,23 @@
 /* conf uline link list root */
 struct ConfItem        *u_conf = ((struct ConfItem *)NULL);
 
+/* conf zline link list root */
+struct ConfItem        *z_conf = ((struct ConfItem *)NULL);
+
+struct Equiv {
+  char *nick;
+  char *target;
+  struct Equiv *next;
+};
+
+static struct Equiv *equivs = NULL;
+static struct Equiv *userparms = NULL;
+static struct Equiv *clusters = NULL;
+
+#define MAXRELAYS 64
+static char *relays[MAXRELAYS];
+static int relaynum = 0;
+
 /*
  * conf_dns_callback
  * inputs	- pointer to struct ConfItem
@@ -316,7 +334,7 @@
             /* except if HIDE_SERVERS_IPS is defined */
 #ifndef HIDE_SERVERS_IPS
             if(IsOperAdmin(source_p))
-              sendto_one(source_p, form_str(p->rpl_stats), me.name,
+              sendto_one(source_p, form_str(source_p,p->rpl_stats), me.name,
                          source_p->name, c,
                          host,
 			 buf,
@@ -326,7 +344,7 @@
                          oper_flags_as_string((int)tmp->hold));
             else
 #endif
-              sendto_one(source_p, form_str(p->rpl_stats), me.name,
+              sendto_one(source_p, form_str(source_p,p->rpl_stats), me.name,
                          source_p->name, c,
                          "*@127.0.0.1",
 			 buf,
@@ -339,7 +357,7 @@
           {
             /* Don't allow non opers to see oper privs */
             if(IsOper(source_p))
-              sendto_one(source_p, form_str(p->rpl_stats), me.name,
+              sendto_one(source_p, form_str(source_p,p->rpl_stats), me.name,
                          source_p->name,
                          p->conf_char,
                          user, host, name,
@@ -347,7 +365,7 @@
                          classname,
                          oper_flags_as_string((int)tmp->hold));
             else
-              sendto_one(source_p, form_str(p->rpl_stats), me.name,
+              sendto_one(source_p, form_str(source_p,p->rpl_stats), me.name,
                          source_p->name, p->conf_char,
                          user, host, name,
                          "0",
@@ -355,7 +373,7 @@
                          "");
           }
         else
-          sendto_one(source_p, form_str(p->rpl_stats), me.name,
+          sendto_one(source_p, form_str(source_p,p->rpl_stats), me.name,
                      source_p->name, p->conf_char,
                      host, name, port,
                      classname);
@@ -396,7 +414,7 @@
         get_printable_conf(aconf, &name, &host, &pass,
                            &user, &port, &classname);
 
-        sendto_one(source_p, form_str(numeric),
+        sendto_one(source_p, form_str(source_p,numeric),
                    me.name,
                    source_p->name,
                    name,
@@ -520,7 +538,8 @@
     {
       aconf = find_address_conf(client_p->host,client_p->username,
 				&client_p->localClient->ip,
-				client_p->localClient->aftype);
+				client_p->localClient->aftype,
+				client_p->localClient->passwd);
     }
   else
     {
@@ -528,7 +547,8 @@
       strlcat(non_ident, username, USERLEN + 1);
       aconf = find_address_conf(client_p->host,non_ident,
 				&client_p->localClient->ip,
-				client_p->localClient->aftype);
+				client_p->localClient->aftype,
+				client_p->localClient->passwd);
     }
 
   if (aconf != NULL)
@@ -537,7 +557,7 @@
 	{
 	  if (aconf->flags & CONF_FLAGS_REDIR)
 	    {
-	      sendto_one(client_p, form_str(RPL_REDIR), me.name, client_p->name,
+	      sendto_one(client_p, form_str(client_p,RPL_REDIR), me.name, client_p->name,
 			 aconf->name ? aconf->name : "", aconf->port);
 	      return(NOT_AUTHORIZED);
 	    }
@@ -568,6 +588,8 @@
 	  /* Thanks for spoof idea amm */
 	  if (IsConfDoSpoofIp(aconf))
 	    {
+	      char *p = strchr(aconf->name, '@');
+
 #ifndef HIDE_SPOOF_IPS
 	      if (IsConfSpoofNotice(aconf))
 		{
@@ -576,7 +598,23 @@
 				       client_p->host, aconf->name);
 		}
 #endif
-	      strlcpy(client_p->host, aconf->name, sizeof(client_p->host));
+	      if (p) 
+		{
+		  int len = p - aconf->name;
+		  if (len > USERLEN) 
+		    len = USERLEN;
+
+		  strcpy(client_p->realhost, client_p->username);
+		  strcat(client_p->realhost, "@");
+		  strncat(client_p->realhost, client_p->host, HOSTLEN - strlen(client_p->username) - 1);
+		  strncpy(client_p->username, aconf->name, len);
+		  if (len)
+		    client_p->username[len] = '\0';
+		}
+	      else
+		strcpy(client_p->realhost, client_p->host);
+	      strncpy(client_p->host, p? p+1 : aconf->name, HOSTLEN);
+
 	      SetIPSpoof(client_p);
 	    }
 	  return(attach_iline(client_p, aconf));
@@ -610,6 +648,9 @@
 
   SetIpHash(client_p);
   ip_found->count++;
+  
+  sendto_realops_flags(FLAGS_DEBUG, L_ALL, "attach_iline(): %s!%s@%s %p %d",
+  	client_p->name, client_p->username, client_p->host, ip_found, ip_found->count);
 
   /* only check it if its non zero */
   if ( aconf->c_class /* This should never non NULL *grin* */ &&
@@ -1207,6 +1248,32 @@
   return(NULL);
 }
 
+/* 
+ * NOTES
+ *
+ * C:192.168.0.240:password:irc.server.name:...
+ * C:irc.server.name:password:irc.server.name
+ * C:host:passwd:name:port:class
+ * N:host:passwd:name:hostmask number:class
+ */
+/*
+ * Added for new access check    meLazy <- no youShithead, your code sucks
+ */
+struct ConfItem* find_conf_host(dlink_list *list, const char* host, 
+                                int statmask)
+{
+  dlink_node *ptr;
+  struct ConfItem *aconf;
+  
+  for (ptr = list->head; ptr; ptr = ptr->next)
+    {
+      aconf = ptr->data;
+      if (aconf->status & statmask && aconf->host && match(aconf->host, host))
+        return aconf;
+    }
+  return NULL;
+}
+
 /*
  * find_x_conf
  *
@@ -1262,6 +1329,43 @@
   return(NO);
 }
 
+int find_z_conf(char *server)
+{
+  struct ConfItem *aconf;
+
+  for (aconf = z_conf; aconf; aconf = aconf->next)
+    {
+      if (BadPtr(aconf->name))
+          continue;
+
+      if(match(aconf->name,server))
+		{
+	  		if (BadPtr(aconf->user) || BadPtr(aconf->host))
+	    		return YES;
+
+		}
+    }
+  return NO;
+}
+
+void report_zlines(struct Client *source_p)
+{
+  struct ConfItem *aconf;
+  char *host;
+  char *user;
+  char *pass;
+  char *name;
+  char *classname;
+  int  port;
+
+  for (aconf = z_conf; aconf; aconf = aconf->next)
+    {
+      get_printable_conf(aconf, &name, &host, &pass, &user, &port,&classname);
+          
+      sendto_one(source_p, form_str(source_p,RPL_STATSZLINE),
+		 me.name, source_p->name, name);
+    }
+}
 
 /*
  * clear_special_conf
@@ -1356,6 +1460,7 @@
   ServerInfo.max_buffer = MAX_BUFFER;    /*       actually do anything! */
   /* Don't reset hub, as that will break lazylinks */
   /* ServerInfo.hub = NO; */
+  ServerInfo.gateway = NO;
   ServerInfo.dns_host.sin_addr.s_addr = 0;
   ServerInfo.dns_host.sin_port = 0;
   AdminInfo.name = NULL;
@@ -1426,6 +1531,8 @@
   ConfigChannel.use_invex   = YES;
   ConfigChannel.use_knock   = YES;
   ConfigChannel.use_vchans = NO;
+  ConfigChannel.use_subst = NO;
+  ConfigChannel.use_denies = NO;
   ConfigChannel.knock_delay = 300;
   ConfigChannel.knock_delay_channel = 60;
   ConfigChannel.max_chans_per_user = 15;
@@ -1447,6 +1554,13 @@
   ConfigFileEntry.min_nonwildcard = 4;
   ConfigFileEntry.default_floodcount = 8;
   ConfigFileEntry.client_flood = CLIENT_FLOOD_DEFAULT;
+  ConfigFileEntry.grace_time = GRACE_TIME_DEFAULT;
+  ConfigFileEntry.repeat_grace = REPGRACEDEF;
+  ConfigFileEntry.spam_wait = SPAM_WAIT_DEFAULT;
+  ConfigFileEntry.drone_rate_max = DRONE_RMAX_DEF;
+  ConfigFileEntry.drone_rate_period = DRONE_RPERIOD_DEF;
+  ConfigFileEntry.drone_kline_time = DRONE_KTIME_DEF;
+  strcpy(ConfigFileEntry.spawn_pass, "spawn");
 
 #ifdef IPV6  
   ConfigFileEntry.fallback_to_ip6_int = 1;
@@ -1841,7 +1955,7 @@
 oper_flags_as_string(int flags)
 {
   /* This MUST be extended if we add any more modes... -Hwy */
-  static char flags_out[18];
+  static char flags_out[32];
   char *flags_ptr;
 
   flags_ptr = flags_out;
@@ -1879,6 +1993,8 @@
     *flags_ptr++ = 'l';
   if(flags & FLAGS_CALLERID)
     *flags_ptr++ = 'g';
+  if(flags & FLAGS_REMOTE)
+    *flags_ptr++ = 'q';
   *flags_ptr = '\0';
 
   return(flags_out);
@@ -2103,6 +2219,41 @@
   clear_out_address_conf();
   clear_special_conf(&x_conf);
   clear_special_conf(&u_conf);
+  clear_special_conf(&z_conf);
+
+  {
+      int i;
+      struct Equiv *eitem;
+
+      if (equivs) do {
+		eitem = equivs;
+		equivs = equivs->next;
+		MyFree(eitem->nick);
+		MyFree(eitem->target);
+		MyFree(eitem);
+      } while (equivs);
+
+      if (userparms) do {
+		eitem = userparms;
+		userparms = userparms->next;
+		MyFree(eitem->nick);
+		MyFree(eitem->target);
+		MyFree(eitem);
+      } while (userparms);
+
+      if (clusters) do {
+		eitem = clusters;
+		clusters = clusters->next;
+		MyFree(eitem->nick);
+		MyFree(eitem->target);
+		MyFree(eitem);
+      } while (clusters);
+
+      for (i=0; i<relaynum; i++)
+		MyFree(relays[i]);
+
+      relaynum = 0;
+  }
 
   /* clean out module paths */
 #ifndef STATIC_MODULES
@@ -2158,6 +2309,211 @@
   /* OK, that should be everything... */
 }
 
+/* these deal with the equivalent nicks stuff
+ *                                  -demond
+ */
+void report_equivs(struct Client* source_p)
+{
+  struct Equiv *eitem;
+
+  for (eitem = equivs; eitem; eitem = eitem->next)
+    sendto_one(source_p, form_str(source_p,RPL_EQUIVALENTS),
+	       me.name, source_p->name, 
+	       eitem->nick, eitem->target);
+}
+
+void add_equiv_nicks(char *nicks)
+{
+  char *p, *q, *buf;
+  struct Equiv *eitem;
+
+  DupString(buf, nicks);
+  p = strchr(buf, '/');
+
+  if (p) {
+    *p = 0; ++p;
+    
+    if (*p) {
+
+      eitem = (struct Equiv*) MyMalloc(sizeof(struct Equiv));
+
+      DupString(q, buf); eitem->nick = q;
+      DupString(q, p); eitem->target = q;
+
+      eitem->next = equivs;
+      equivs = eitem;
+    }
+  }
+
+  MyFree(buf);
+}
+
+/* cluster/bridge stuff helper functions
+ *                            -demond
+ */
+void report_clusters(struct Client* source_p)
+{
+  struct Equiv *eitem;
+
+  for (eitem = clusters; eitem; eitem = eitem->next)
+    sendto_one(source_p, form_str(source_p,RPL_CLUSTERBRIDGE),
+	       me.name, source_p->name, 
+	       eitem->nick, eitem->target);
+}
+
+void add_cluster_bridge(char *bridge)
+{
+  char *p, *q, *buf;
+  struct Equiv *eitem;
+
+  DupString(buf, bridge);
+  p = strchr(buf, '/');
+
+  if (p) {
+    *p = 0; ++p;
+    
+    if (*p) {
+
+      eitem = (struct Equiv*) MyMalloc(sizeof(struct Equiv));
+
+      DupString(q, buf); eitem->nick = q;
+      DupString(q, p); eitem->target = q;
+
+      eitem->next = clusters;
+      clusters = eitem;
+    }
+  }
+
+  MyFree(buf);
+}
+
+/* USER constant parameter handling
+ *                        -demond
+ */
+void add_userpar_param(char *param)
+{
+  char *p, *q, *buf;
+  struct Equiv *eitem;
+
+  if (!param[0]) return;
+
+  DupString(buf, param);
+  p = strchr(buf, '/');
+
+  eitem = (struct Equiv*) MyMalloc(sizeof(struct Equiv));
+
+  if (p) {
+
+    *p = 0; ++p;
+	DupString(q, buf); eitem->nick = q;
+    
+    if (*p) {
+
+      DupString(q, p); eitem->target = q;
+    }
+
+  } else {
+	
+	DupString(q, buf); eitem->nick = q;
+  }
+
+  eitem->next = userparms;
+  userparms = eitem;
+
+  MyFree(buf);
+}
+
+void report_userparms(struct Client* source_p)
+{
+  struct Equiv *eitem;
+
+  for (eitem = userparms; eitem; eitem = eitem->next)
+    sendto_one(source_p, form_str(source_p,RPL_USERPARMS),
+	       me.name, source_p->name, eitem->nick, 
+		   eitem->target? eitem->target : "<NULL>");
+}
+
+int IsUserPar(char *host, char *server)
+{
+	struct Equiv *eitem;
+
+	for (eitem = userparms; eitem; eitem = eitem->next)
+		if (strcmp(host, eitem->nick) == 0)
+			if (eitem->target) {
+				if (strcmp(server, eitem->target) == 0)
+					return 1;
+			} else
+				return 1;
+
+	return 0;
+}
+
+/* bot relay servers, ignored for various reasons
+ *                                       -demond
+ */
+void add_relay_server(char *name)
+{
+
+  if (relaynum < MAXRELAYS)
+    DupString(relays[relaynum++], name);
+}
+
+void report_relays(struct Client* source_p)
+{
+  int i;
+
+  for (i=0; i<relaynum; i++)
+    sendto_one(source_p, form_str(source_p,RPL_RELAYS),
+	       me.name, source_p->name, relays[i]); 
+}
+
+int IsRelay(struct Client* client_p)
+{
+  int i;
+
+  for (i=0; i<relaynum; i++)
+    if (irccmp(relays[i], client_p->name) == 0)
+      return 1;
+
+  return 0;
+}
+
+char *get_equiv_nick(char *nick, char *target)
+{
+  struct Equiv *eitem;
+
+  for (eitem = equivs; eitem; eitem = eitem->next)
+    if (irccmp(nick, eitem->nick) == 0) {
+
+      strncpy(target, eitem->target, NICKLEN);
+      return target;
+    }
+
+  return NULL;
+}
+
+char *get_bridge_token(struct Client *client_p)
+{
+  struct Equiv *eitem;
+
+  for (eitem = clusters; eitem; eitem = eitem->next)
+    if (irccmp(client_p->name, eitem->nick) == 0)
+      return eitem->target;
+
+  return NULL;
+}
+
+int HasBridgeToken(char *str)
+{
+  struct Equiv *eitem;
+
+  for (eitem = clusters; eitem; eitem = eitem->next)
+    if (ircncmp(str, eitem->target, strlen(eitem->target)) == 0)
+      return 1;
+
+  return 0;
+}
+
 /*
  * flush_deleted_I_P
  *
@@ -2445,6 +2801,11 @@
   u_conf = aconf;
 }
 
+void conf_add_z_conf(struct ConfItem *aconf)
+{
+  aconf->next = z_conf;
+  z_conf = aconf;
+}
 
 /*
  * conf_add_fields
diff -uNrd -x CVS ircd-hybrid-7rc5/src/s_debug.c ircd-hybrid-7-bg/src/s_debug.c
--- ircd-hybrid-7rc5/src/s_debug.c	Fri May 24 19:34:51 2002
+++ ircd-hybrid-7-bg/src/s_debug.c	Mon Mar 10 01:09:06 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_debug.c,v 7.67 2002/05/24 23:34:51 androsyn Exp $
+ *  $Id: s_debug.c,v 1.2 2003/03/10 06:09:06 demond Exp $
  */
 
 #include "stdinc.h"
@@ -162,6 +162,8 @@
   int channel_bans = 0;      
   int channel_except = 0;
   int channel_invex = 0;
+  int channel_subst = 0;
+  int channel_denies = 0;
 
   int wwu = 0;                  /* whowas users */
   int class_count = 0;          /* classes */
@@ -176,6 +178,8 @@
   u_long channel_ban_memory = 0;
   u_long channel_except_memory = 0;
   u_long channel_invex_memory = 0;
+  u_long channel_subst_memory = 0;
+  u_long channel_denies_memory = 0;
 
   u_long away_memory = 0;       /* memory used by aways */
   u_long wwm = 0;               /* whowas array memory used */
@@ -233,7 +237,7 @@
         }
     }
 
-  /* Count up all channels, ban lists, except lists, Invex lists */
+  /* Count up all channels, ban lists, except lists, Invex, subst words lists */
 
   for (chptr = GlobalChannelList; chptr; chptr = chptr->nextch)
     {
@@ -296,6 +300,32 @@
           if (actualBan->who)
             channel_invex_memory += strlen(actualBan->who);
         }
+    
+	  for (dlink = chptr->substlist.head; dlink; dlink = dlink->next)
+        {
+	  actualBan = dlink->data;
+          channel_subst++;
+
+          channel_subst_memory += (sizeof(dlink_node) + 
+				   sizeof(struct Ban));
+          if (actualBan->banstr)
+            channel_subst_memory += strlen(actualBan->banstr);
+          if (actualBan->who)
+            channel_subst_memory += strlen(actualBan->who);
+        }
+    
+	  for (dlink = chptr->denylist.head; dlink; dlink = dlink->next)
+        {
+	  actualBan = dlink->data;
+          channel_denies++;
+
+          channel_denies_memory += (sizeof(dlink_node) + 
+				   sizeof(struct Ban));
+          if (actualBan->banstr)
+            channel_denies_memory += strlen(actualBan->banstr);
+          if (actualBan->who)
+            channel_denies_memory += strlen(actualBan->who);
+        }
     }
 
   /* count up all config items */
@@ -354,6 +384,14 @@
   sendto_one(source_p, ":%s %d %s :Invex %u(%d)",
              me.name, RPL_STATSDEBUG, source_p->name,
 	     channel_invex, (int)channel_invex_memory);
+
+  sendto_one(source_p, ":%s %d %s :Subst %u(%d)",
+             me.name, RPL_STATSDEBUG, source_p->name,
+	     channel_subst, (int)channel_subst_memory);
+
+  sendto_one(source_p, ":%s %d %s :Denies %u(%d)",
+             me.name, RPL_STATSDEBUG, source_p->name,
+	     channel_denies, (int)channel_denies_memory);
 
   sendto_one(source_p, ":%s %d %s :Channel members %u(%lu) invite %u(%lu)",
              me.name, RPL_STATSDEBUG, source_p->name, channel_users,
diff -uNrd -x CVS ircd-hybrid-7rc5/src/s_gline.c ircd-hybrid-7-bg/src/s_gline.c
--- ircd-hybrid-7rc5/src/s_gline.c	Wed Sep  4 22:48:42 2002
+++ ircd-hybrid-7-bg/src/s_gline.c	Mon Dec 30 23:07:27 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_gline.c,v 1.23 2002/09/05 02:48:42 db Exp $
+ *  $Id: s_gline.c,v 1.1.1.1 2002/12/31 04:07:27 demond Exp $
  */
 
 #include "stdinc.h"
diff -uNrd -x CVS ircd-hybrid-7rc5/src/s_log.c ircd-hybrid-7-bg/src/s_log.c
--- ircd-hybrid-7rc5/src/s_log.c	Mon Sep  9 09:43:48 2002
+++ ircd-hybrid-7-bg/src/s_log.c	Mon Dec 30 23:07:27 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_log.c,v 7.45 2002/09/09 13:43:48 db Exp $
+ *  $Id: s_log.c,v 1.1.1.1 2002/12/31 04:07:27 demond Exp $
  */
 
 #include "stdinc.h"
@@ -212,7 +212,8 @@
 	  (signed long) on_for / 3600,
 	  (signed long) (on_for % 3600)/60,
 	  (signed long) on_for % 60,
-	  source_p->name, source_p->username, source_p->host,
+	  source_p->name, source_p->username, 
+	  source_p->realhost[0]? source_p->realhost : source_p->host,
 	  source_p->localClient->sendK,
 	  source_p->localClient->receiveK);
     }
@@ -246,7 +247,8 @@
 		   (signed long) on_for / 3600,
 		   (signed long) (on_for % 3600)/60,
 		   (signed long) on_for % 60,
-		   source_p->name, source_p->username, source_p->host,
+		   source_p->name, source_p->username, 
+		   source_p->realhost[0]? source_p->realhost : source_p->host,
 		   source_p->localClient->sendK,
 		   source_p->localClient->receiveK);
 	
